(function(){
  var ref$, id, map, fold, filter, replicate, zip, empty, reverse, concatMap, toClosedShape, slice$ = [].slice;
  ref$ = require('prelude-ls'), id = ref$.id, map = ref$.map, fold = ref$.fold, filter = ref$.filter, replicate = ref$.replicate, zip = ref$.zip, empty = ref$.empty, reverse = ref$.reverse, concatMap = ref$.concatMap;
  toClosedShape = function(result){
    return result.concat(reverse(map(function(arg$){
      var x, y;
      x = arg$.x, y = arg$.y;
      return {
        x: x,
        y: -y
      };
    })(
    result)), [result[0]]);
  };
  module.exports = function(arg$){
    var Plottable, d3;
    Plottable = arg$.Plottable, d3 = arg$.d3;
    return new Plottable(function(view, result, arg$){
      var margin, color, name, size, width, height, shapes, x, gwidth, line, pformat, nformat, x$, y$, z$, z1$, z2$, z3$, z4$, z5$, z6$, z7$, z8$, z9$, z10$;
      margin = arg$.margin, color = arg$.color, name = arg$.name, size = arg$.size;
      width = view.clientWidth - margin.left - margin.right;
      height = view.clientHeight - margin.top - margin.bottom;
      shapes = fold(function(acc, a){
        var latest;
        latest = acc[acc.length - 1];
        switch (false) {
        case !empty(acc):
          return [import$({
            ratio: 1
          }, a)];
        default:
          return acc.concat([import$({
            ratio: a.points[0].y / latest.points[0].y
          }, a)]);
        }
      }, [])(
      map(function(arg$){
        var x, data, name;
        x = arg$.x, data = arg$.data, name = arg$.name;
        return {
          name: name,
          x: x,
          points: toClosedShape([
            {
              x: 0,
              y: size(data[0])
            }, {
              x: 1,
              y: size(data[1])
            }
          ])
        };
      })(
      function(shapes){
        return map(function(arg$){
          var data, x;
          data = arg$[0], x = arg$[1];
          return {
            x: x,
            data: data,
            name: name(data[0]) + ""
          };
        })(
        zip(shapes, (function(){
          var i$, to$, results$ = [];
          for (i$ = 1, to$ = shapes.length + 1; i$ <= to$; ++i$) {
            results$.push(i$);
          }
          return results$;
        }())));
      }(
      function(shapes){
        return shapes.concat([replicate(2, shapes[shapes.length - 1][1])]);
      }(
      fold(function(acc, a){
        var i$, init, latest;
        init = 0 < (i$ = acc.length - 1) ? slice$.call(acc, 0, i$) : (i$ = 0, []), latest = acc[i$];
        switch (false) {
        case !empty(acc):
          return [[a]];
        case !(latest.length < 2):
          return init.concat([latest.concat([a])]);
        default:
          return acc.concat([[latest[1], a]]);
        }
      }, [])(
      fold(function(acc, a){
        var latest;
        latest = acc[acc.length - 1];
        switch (false) {
        case !empty(acc):
          return [a];
        case !(latest.size < a.size):
          return acc;
        default:
          return acc.concat([a]);
        }
      }, [])(
      result))))));
      x = d3.scale.linear().range([0, width]).domain([1, shapes.length + 1]);
      gwidth = x(2) - x(1);
      line = function(){
        var xl, yl;
        xl = d3.scale.linear().range([0, gwidth]).domain([0, 1]);
        yl = d3.scale.linear().range([height, 0]).domain(d3.extent(concatMap(function(it){
          return map(function(it){
            return it.y;
          })(
          it.points);
        })(
        shapes)));
        return d3.svg.line().x(function(it){
          return xl(
          it.x);
        }).y(function(it){
          return yl(
          it.y);
        }).interpolate('linear');
      }();
      pformat = d3.format('%');
      nformat = d3.format(',f');
      x$ = d3.select(view).selectAll("div.funnel").data([shapes]);
      y$ = x$.enter();
      z$ = y$.append('div').attr('class', 'funnel').attr('style', "font-size: 12px");
      z$.append('svg').attr('width', width + margin.left + margin.right).attr('height', height + margin.top + margin.bottom).append('g').attr('transform', function(){
        return "translate(" + margin.left + ", " + margin.top + ")";
      });
      z1$ = x$.select('svg');
      z2$ = z1$.selectAll('g.shape').data(id);
      z3$ = z2$.enter();
      z4$ = z3$.append('g').attr('class', 'shape').attr('transform', function(it){
        return "translate(" + x(it.x) + ", 0)";
      });
      z5$ = z4$.append('path');
      z5$.attr('d', compose$(function(it){
        return it.points;
      }, line));
      z5$.attr('fill', color);
      z6$ = z4$.append('g').attr('transform', function(){
        return "translate(" + gwidth / 2 + ", " + (height / 2 + 10) + ")";
      });
      z7$ = z6$.append('text').attr('class', 'name');
      z7$.attr('text-anchor', 'middle').attr('dominant-baseline', 'central');
      z7$.attr('dy', '-2em').text(function(it){
        return it.name;
      });
      z8$ = z6$.append('text').attr('class', 'val');
      z8$.attr('text-anchor', 'middle').attr('dominant-baseline', 'central');
      z8$.attr('dy', '0em').text(compose$(function(it){
        return it.points[0].y;
      }, nformat));
      z9$ = z6$.append('text').attr('class', 'ratio');
      z9$.attr('text-anchor', 'middle').attr('dominant-baseline', 'central');
      z9$.attr('dy', '2em').text(compose$(function(it){
        return it.ratio;
      }, pformat));
      z2$.attr('transform', function(it){
        return "translate(" + x(it.x) + ", 0)";
      });
      z10$ = z2$.select('path');
      z10$.attr('d', compose$(function(it){
        return it.points;
      }, line));
      z10$.attr('fill', color);
      z2$.select('text.name').text(function(it){
        return it.name;
      });
      z2$.select('text.val').text(compose$(function(it){
        return it.points[0].y;
      }, nformat));
      z2$.select('text.ratio').text(compose$(function(it){
        return it.ratio;
      }, pformat));
      return x$;
    }, {
      margin: {
        top: 20,
        right: 20,
        bottom: 20,
        left: 20
      },
      color: compose$(function(it){
        return it.ratio;
      }, d3.scale.linear().domain([1, 0.75, 0]).range(['#2c7bb6', '#ffffbf', '#d7191c']).interpolate(d3.interpolateHcl)),
      name: function(it){
        return it.name;
      },
      size: function(it){
        return it.size;
      }
    });
  };
  function import$(obj, src){
    var own = {}.hasOwnProperty;
    for (var key in src) if (own.call(src, key)) obj[key] = src[key];
    return obj;
  }
  function compose$() {
    var functions = arguments;
    return function() {
      var i, result;
      result = functions[0].apply(this, arguments);
      for (i = 1; i < functions.length; ++i) {
        result = functions[i](result);
      }
      return result;
    };
  }
}).call(this);
