(function(){
  var ref$, map, id, reverse;
  ref$ = require('prelude-ls'), map = ref$.map, id = ref$.id, reverse = ref$.reverse;
  module.exports = function(arg$){
    var Plottable, d3;
    Plottable = arg$.Plottable, d3 = arg$.d3;
    return new Plottable(function(view, result, options){
      var range, size, ref$, color, columnColor, colorRange, vertical, flip, domainMax, domainMin, scale, ramp, x$, y$, z$, z1$, z2$, z3$, z4$, z5$;
      range = options.range || [1, 350], size = (ref$ = options.size) != null ? ref$ : 50, color = (ref$ = options.color) != null ? ref$ : '#fff', columnColor = options.columnColor, colorRange = options.colorRange || ["red", "blue"], vertical = options.vertical, flip = options.flip;
      domainMax = d3.max(result, function(it){
        return it[1];
      });
      domainMin = d3.min(result, function(it){
        return it[1];
      });
      scale = d3.scale.linear().domain([domainMin, domainMax]).range(range);
      ramp = d3.scale.linear().domain([domainMin, domainMax]).range(colorRange);
      x$ = d3.select(view);
      y$ = x$.append('div').selectAll('div').data(flip ? reverse(
      result) : result);
      z$ = y$.enter();
      z1$ = z$.append('div');
      z2$ = z1$.append('p');
      z2$.text(function(arg$){
        var label;
        label = arg$[0];
        return label;
      });
      z3$ = z1$.append('p');
      z3$.text(function(arg$){
        var _, num;
        _ = arg$[0], num = arg$[1];
        return num;
      });
      z1$.attr('style', function(arg$){
        var _, num, color;
        _ = arg$[0], num = arg$[1], color = arg$[2];
        return (["background: " + (color || columnColor || ramp(num)), "text-align: center"].concat(vertical
          ? ["width: " + scale(num) + "px", "height: " + size + "px", "margin: auto", "border-bottom: solid 1px white"]
          : ["height: " + scale(num) + "px", "width: " + size + "px", "margin: auto 0", "border-right: solid 1px white"])).join(';');
      });
      z4$ = x$.select('div');
      z4$.attr('style', ([].concat(!vertical
        ? "display: flex"
        : [])).join(';'));
      z4$.attr('class', 'funnel1-container');
      z5$ = x$.selectAll('p');
      z5$.attr('style', "padding: 0; margin: 0; color: " + color);
      return x$;
    });
  };
}).call(this);
