(function(){
  var ref$, map, id, each, fillIntervals, fillIntervalsF;
  ref$ = require('prelude-ls'), map = ref$.map, id = ref$.id, each = ref$.each;
  fillIntervals = require('./_utils').fillIntervals;
  fillIntervalsF = fillIntervals;
  module.exports = function(params){
    var Plottable, nv, plotChart, ref$, plotter, options;
    Plottable = params.Plottable, nv = params.nv, plotChart = params.plotChart;
    ref$ = require('./nv-template')(params), plotter = ref$.plotter, options = ref$.options;
    return new Plottable(plotter(function(refinedSeries, arg$){
      var fillIntervals, x, y;
      fillIntervals = arg$.fillIntervals, x = arg$.x, y = arg$.y;
      return map(function(series){
        var values, projectedValues, ref$;
        values = series.values;
        projectedValues = function(it){
          if (fillIntervals !== false) {
            return fillIntervalsF(it, fillIntervals === true ? 0 : fillIntervals);
          } else {
            return it;
          }
        }(
        map(function(it){
          return [x(it), y(it)];
        })(
        values));
        return ref$ = import$({}, series), ref$.values = projectedValues, ref$;
      })(
      refinedSeries);
    }, function(it){
      return it.multiBarChart;
    }, function(chart, arg$, arg1$, options){
      var groupSpacing, reduceXTicks, rotateLabels, showControls, showLegend, transitionDuration;
      groupSpacing = options.groupSpacing, reduceXTicks = options.reduceXTicks, rotateLabels = options.rotateLabels, showControls = options.showControls, showLegend = options.showLegend, transitionDuration = options.transitionDuration;
      chart.x(function(it){
        return it[0];
      }).y(function(it){
        return it[1];
      }).duration(transitionDuration).groupSpacing(groupSpacing).reduceXTicks(reduceXTicks).rotateLabels(rotateLabels).showControls(showControls).showLegend(showLegend);
    }), (ref$ = import$({}, options), ref$.groupSpacing = 0.1, ref$.reduceXTicks = false, ref$.rotateLabels = 0, ref$.showControls = true, ref$.showLegend = true, ref$.transitionDuration = 300, ref$));
  };
  function import$(obj, src){
    var own = {}.hasOwnProperty;
    for (var key in src) if (own.call(src, key)) obj[key] = src[key];
    return obj;
  }
}).call(this);
