(function(){
  var ref$, each, map, id;
  ref$ = require('prelude-ls'), each = ref$.each, map = ref$.map, id = ref$.id;
  module.exports = function(params){
    var Plottable, d3, plotChart, nv, ref$, plotter, options;
    Plottable = params.Plottable, d3 = params.d3, plotChart = params.plotChart, nv = params.nv;
    ref$ = require('./nv-template')(params), plotter = ref$.plotter, options = ref$.options;
    return new Plottable(plotter(function(refinedSeries, arg$){
      var x, y;
      x = arg$.x, y = arg$.y;
      return map(function(series){
        var values, ref$;
        values = series.values;
        return ref$ = import$({}, series), ref$.values = map(function(it){
          return {
            x: x(it),
            y: y(it)
          };
        })(
        values), ref$;
      })(
      refinedSeries);
    }, function(it){
      return it.multiBarHorizontalChart;
    }, function(chart, arg$, arg1$, arg2$){
      var showValues, showControls, stacked;
      showValues = arg2$.showValues, showControls = arg2$.showControls, stacked = arg2$.stacked;
      chart.showControls(showControls).showValues(showValues).stacked(stacked);
    }), (ref$ = import$({}, options), ref$.showValues = true, ref$.showControls = true, ref$.stacked = false, ref$));
  };
  function import$(obj, src){
    var own = {}.hasOwnProperty;
    for (var key in src) if (own.call(src, key)) obj[key] = src[key];
    return obj;
  }
}).call(this);
