(function(){
  var ref$, each, filter, map, id, unique, $;
  ref$ = require('prelude-ls'), each = ref$.each, filter = ref$.filter, map = ref$.map, id = ref$.id, unique = ref$.unique;
  $ = require('jquery-browserify');
  module.exports = function(params){
    var Plottable, nv, plotChart, ref$, plotter, options;
    Plottable = params.Plottable, nv = params.nv, plotChart = params.plotChart;
    ref$ = require('./nv-template')(params), plotter = ref$.plotter, options = ref$.options;
    return new Plottable(plotter(function(refinedSeries, arg$){
      var x, y;
      x = arg$.x, y = arg$.y;
      return map(function(series){
        var values, ref$;
        values = series.values;
        return ref$ = import$({}, series), ref$.values = map(function(it){
          return {
            x: x(it),
            y: y(it)
          };
        })(
        values), ref$;
      })(
      refinedSeries);
    }, function(it){
      return it.multiChart;
    }, function(chart, view, arg$, arg1$){
      var yAxis1, yAxis2, this$ = this;
      yAxis1 = arg1$.yAxis1, yAxis2 = arg1$.yAxis2;
      each(function(arg$){
        var f, prop;
        f = arg$[0], prop = arg$[1];
        return f(chart)(prop);
      })(
      filter(function(it){
        return !!it[1];
      })(
      [
        [
          function(it){
            return it.yAxis1.tickFormat;
          }, yAxis1.format
        ], [
          function(it){
            return it.yAxis1.axisLabel;
          }, yAxis1.label
        ], [
          function(it){
            return it.yAxis1.axisLabelDistance;
          }, yAxis1.distance
        ], [
          function(it){
            return it.yAxis2.tickFormat;
          }, yAxis2.format
        ], [
          function(it){
            return it.yAxis2.axisLabel;
          }, yAxis2.label
        ], [
          function(it){
            return it.yAxis2.axisLabelDistance;
          }, yAxis2.distance
        ]
      ]));
      if (typeof (yAxis1 != null ? yAxis1.show : void 8) === 'boolean') {
        $(view).find('div').toggleClass('hide-y1', !yAxis1.show);
      }
      if (typeof (yAxis2 != null ? yAxis2.show : void 8) === 'boolean') {
        $(view).find('div').toggleClass('hide-y2', !yAxis2.show);
      }
    }), (ref$ = import$({}, options), ref$.yAxis1 = {
      format: id,
      label: null,
      show: true
    }, ref$.yAxis2 = {
      format: id,
      label: null,
      show: true
    }, ref$));
  };
  function import$(obj, src){
    var own = {}.hasOwnProperty;
    for (var key in src) if (own.call(src, key)) obj[key] = src[key];
    return obj;
  }
}).call(this);
