(function(){
  var ref$, map, floor, ξ;
  ref$ = require('prelude-ls'), map = ref$.map, floor = ref$.floor;
  ξ = curry$(function(h, f, g){
    return function(x){
      return h(f(x), g(x));
    };
  });
  module.exports = function(params){
    var Plottable, d3, nv, ref$, plotter, options, continuations, projection;
    Plottable = params.Plottable, d3 = params.d3, nv = params.nv;
    ref$ = require('./scatter')(params), plotter = ref$.plotter, options = ref$.options, continuations = ref$.continuations, projection = ref$.projection;
    return new Plottable(plotter, (ref$ = import$({}, options), ref$.k = function(){
      return arguments[0] + "_" + arguments[1] + "_" + floor(Math.random() * 10000);
    }, ref$), continuations, function(data, arg$){
      var k, x, y;
      if (arg$ != null) {
        k = arg$.k, x = arg$.x, y = arg$.y;
      }
      return projection(map(function(item){
        var ref$;
        return ref$ = import$({}, item), ref$.key = ξ(k, x, y)(item), ref$.values = [item], ref$;
      })(
      data), options);
    });
  };
  function curry$(f, bound){
    var context,
    _curry = function(args) {
      return f.length > 1 ? function(){
        var params = args ? args.concat() : [];
        context = bound ? context || this : this;
        return params.push.apply(params, arguments) <
            f.length && arguments.length ?
          _curry.call(context, params) : f.apply(context, params);
      } : f;
    };
    return _curry();
  }
  function import$(obj, src){
    var own = {}.hasOwnProperty;
    for (var key in src) if (own.call(src, key)) obj[key] = src[key];
    return obj;
  }
}).call(this);
