(function(){
  var ref$, map, id, $, h337;
  ref$ = require('prelude-ls'), map = ref$.map, id = ref$.id;
  $ = require('jquery-browserify');
  h337 = require('heatmap.js/heatmap.min.js');
  module.exports = function(arg$){
    var Plottable;
    Plottable = arg$.Plottable;
    return new Plottable(curry$(function(view, result, arg$, continuation){
      var width, height, background, heatmapContainer, heatmapInstance;
      width = arg$.width, height = arg$.height, background = arg$.background;
      heatmapContainer = $(view).find('.heatmap-container');
      if (heatmapContainer.size() === 0) {
        heatmapContainer = $("<div/>").addClass('heatmap-container');
        $(view).append(heatmapContainer);
      }
      heatmapContainer.css({
        width: width,
        height: height,
        backgroundImage: "url('" + background + "')"
      });
      heatmapInstance = heatmapContainer.data('heatmap-instance');
      if (!heatmapInstance) {
        heatmapInstance = h337.create({
          container: heatmapContainer.get(0)
        });
        heatmapContainer.data('heatmap-instance', heatmapInstance);
      }
      heatmapInstance.setData(result);
    }), {
      width: 320,
      height: 568,
      background: null
    });
  };
  function curry$(f, bound){
    var context,
    _curry = function(args) {
      return f.length > 1 ? function(){
        var params = args ? args.concat() : [];
        context = bound ? context || this : this;
        return params.push.apply(params, arguments) <
            f.length && arguments.length ?
          _curry.call(context, params) : f.apply(context, params);
      } : f;
    };
    return _curry();
  }
}).call(this);
