(function(){
  var ref$, map, id, filter, Obj, pairsToObj, sum, each, take, drop, createClass, createFactory, div, findDOMNode, render, toString$ = {}.toString, slice$ = [].slice;
  ref$ = require('prelude-ls'), map = ref$.map, id = ref$.id, filter = ref$.filter, Obj = ref$.Obj, pairsToObj = ref$.pairsToObj, sum = ref$.sum, each = ref$.each, take = ref$.take, drop = ref$.drop;
  ref$ = require('react'), createClass = ref$.createClass, createFactory = ref$.createFactory, div = ref$.DOM.div;
  ref$ = require('react-dom'), findDOMNode = ref$.findDOMNode, render = ref$.render;
  module.exports = function(arg$){
    var Plottable, d3, plotChart, nv, plot, Cell, Layout, layout;
    Plottable = arg$.Plottable, d3 = arg$.d3, plotChart = arg$.plotChart, nv = arg$.nv, plot = arg$.plot;
    Cell = createFactory(createClass({
      getDefaultProps: function(){
        return {};
      },
      render: function(){
        var style;
        style = this.props.style;
        return div({
          style: style
        });
      },
      updatePlot: function(){
        plot(this.props.plottable, findDOMNode(this), this.props.result, this.props.options);
      },
      componentDidMount: function(){
        this.updatePlot();
      },
      componentDidUpdate: function(){
        this.updatePlot();
      }
    }));
    Layout = createFactory(createClass({
      getDefaultProps: function(){
        return {};
      },
      render: function(){
        var ref$, cells, direction, result, options, sizes, emptySpace, cellsWithoutSize, defaultSize, cellsWithSize, this$ = this;
        ref$ = this.props, cells = ref$.cells, direction = ref$.direction, result = ref$.result, options = ref$.options;
        sizes = filter(function(it){
          return !!it && toString$.call(it).slice(8, -1) === 'Number';
        })(
        map(function(it){
          return it.size;
        })(
        cells));
        emptySpace = 1 - sum(sizes);
        cellsWithoutSize = cells.length - sizes.length;
        defaultSize = emptySpace / cellsWithoutSize;
        cellsWithSize = map(function(it){
          var ref$, ref1$;
          return ref$ = import$({}, it), ref$.size = (ref1$ = it.size) != null ? ref1$ : defaultSize, ref$;
        })(
        cells);
        return div(null, map(function(i){
          var ref$, size, plottable, position;
          ref$ = cellsWithSize[i], size = ref$.size, plottable = ref$.plottable;
          position = sum(
          map(function(it){
            return it.size;
          })(
          take(i)(
          cellsWithSize)));
          return Cell({
            key: "cell_" + i,
            style: {
              overflow: 'auto',
              position: 'absolute',
              left: direction === 'horizontal' ? position * 100 + "%" : "0%",
              top: direction === 'horizontal'
                ? "0%"
                : position * 100 + "%",
              width: direction === 'horizontal' ? size * 100 + "%" : "100%",
              height: direction === 'horizontal'
                ? "100%"
                : size * 100 + "%"
            },
            plottable: plottable,
            result: result,
            options: options
          });
        })(
        (function(){
          var i$, to$, results$ = [];
          for (i$ = 0, to$ = cellsWithSize.length; i$ < to$; ++i$) {
            results$.push(i$);
          }
          return results$;
        }())));
      }
    }));
    layout = function(direction){
      var cells;
      cells = slice$.call(arguments, 1);
      return new Plottable(function(view, result, options, continuation){
        render(Layout({
          cells: cells,
          direction: direction,
          result: result,
          options: options
        }), view);
      });
    };
    return {
      cell: function(plottable){
        return {
          plottable: plottable
        };
      },
      scell: function(size, plottable){
        return {
          size: size,
          plottable: plottable
        };
      },
      layoutHorizontal: function(){
        return layout.apply(this, ['horizontal'].concat([].slice.call(arguments)));
      },
      layoutVertical: function(){
        return layout.apply(this, ['vertical'].concat([].slice.call(arguments)));
      }
    };
  };
  function import$(obj, src){
    var own = {}.hasOwnProperty;
    for (var key in src) if (own.call(src, key)) obj[key] = src[key];
    return obj;
  }
}).call(this);
