(function(){
  var ref$, each, concatMap, map, unique, sort, find, id, zipWith, fillIntervals, trendLine, rextend, fillIntervalsF;
  ref$ = require('prelude-ls'), each = ref$.each, concatMap = ref$.concatMap, map = ref$.map, unique = ref$.unique, sort = ref$.sort, find = ref$.find, id = ref$.id, unique = ref$.unique, zipWith = ref$.zipWith;
  ref$ = require('./_utils'), fillIntervals = ref$.fillIntervals, trendLine = ref$.trendLine, rextend = ref$.rextend;
  fillIntervalsF = fillIntervals;
  module.exports = function(params){
    var Plottable, plotChart, d3, nv, ref$, plotter, options;
    Plottable = params.Plottable, plotChart = params.plotChart, d3 = params.d3, nv = params.nv;
    ref$ = require('./nv-template')(params), plotter = ref$.plotter, options = ref$.options;
    return new Plottable(plotter(function(refinedSeries, arg$){
      var fillIntervals, x, y, allValuesOnXAxis;
      fillIntervals = arg$.fillIntervals, x = arg$.x, y = arg$.y;
      allValuesOnXAxis = map(function(it){
        return it[0];
      })(
      function(it){
        if (fillIntervals !== false) {
          return fillIntervalsF(it, 0);
        } else {
          return it;
        }
      }(
      map(function(it){
        return [it, 0];
      })(
      sort(
      unique(
      map(function(it){
        return x(it);
      })(
      concatMap(function(it){
        return it.values;
      })(
      refinedSeries)))))));
      return map(function(series){
        var values, newValues, ref$;
        values = series.values;
        newValues = map(function(valueOnXAxis){
          var ref$, point;
          if ((ref$ = find(function(it){
            return valueOnXAxis === x(it);
          })(
          values)) != null) {
            point = ref$;
          }
          return [
            valueOnXAxis, !!point
              ? y(point)
              : Number(fillIntervals)
          ];
        })(
        allValuesOnXAxis);
        return ref$ = import$({}, series), ref$.values = newValues, ref$;
      })(
      refinedSeries);
    }, function(it){
      return it.stackedAreaChart;
    }, function(chart, arg$, arg1$, arg2$){
      var clipEdge, showControls, showLegend, useInteractiveGuideline;
      clipEdge = arg2$.clipEdge, showControls = arg2$.showControls, showLegend = arg2$.showLegend, useInteractiveGuideline = arg2$.useInteractiveGuideline;
      chart.x(function(it){
        return it[0];
      }).y(function(it){
        return it[1];
      }).clipEdge(clipEdge).showControls(showControls).showLegend(showLegend).useInteractiveGuideline(useInteractiveGuideline);
    }), (ref$ = import$({}, options), ref$.clipEdge = true, ref$.fillIntervals = false, ref$.showLegend = true, ref$.showControls = true, ref$.useInteractiveGuideline = true, ref$));
  };
  function import$(obj, src){
    var own = {}.hasOwnProperty;
    for (var key in src) if (own.call(src, key)) obj[key] = src[key];
    return obj;
  }
}).call(this);
