(function(){
  var map, fillIntervalsF;
  map = require('prelude-ls').map;
  fillIntervalsF = require('./_utils').fillIntervals;
  module.exports = function(params){
    var Plottable, d3, plotChart, nv, ref$, plotter, options;
    Plottable = params.Plottable, d3 = params.d3, plotChart = params.plotChart, nv = params.nv;
    ref$ = require('./nv-template')(params), plotter = ref$.plotter, options = ref$.options;
    return new Plottable(plotter(function(refinedSeries, arg$){
      var fillIntervals, x, y;
      fillIntervals = arg$.fillIntervals, x = arg$.x, y = arg$.y;
      return map(function(series){
        var values, projectedValues, ref$;
        values = series.values;
        projectedValues = function(it){
          if (fillIntervals !== false) {
            return fillIntervalsF(it, fillIntervals === true ? 0 : fillIntervals);
          } else {
            return it;
          }
        }(
        map(function(it){
          return [x(it), y(it)];
        })(
        values));
        return ref$ = import$({}, series), ref$.values = projectedValues, ref$;
      })(
      refinedSeries);
    }, function(it){
      return it.lineChart;
    }, function(chart){
      chart.x(function(it){
        return it[0];
      }).y(function(it){
        return it[1];
      });
    }), (ref$ = import$({}, options), ref$.xAxis = {
      format: function(timestamp){
        return d3.time.format('%x')(new Date(timestamp));
      },
      label: null,
      distance: 0
    }, ref$));
  };
  function import$(obj, src){
    var own = {}.hasOwnProperty;
    for (var key in src) if (own.call(src, key)) obj[key] = src[key];
    return obj;
  }
}).call(this);
